View Issue Details

IDProjectCategoryView StatusLast Update
0001304OpenMPTAudio I/Opublic2020-05-15 20:38
ReporterStardown Assigned To 
PrioritynormalSeverityminorReproducibilityrandom
Status newResolutionopen 
Platformx64OSWindowsOS Version10
Product VersionOpenMPT 1.28.09.00 / libopenmpt 0.4.11 (upgrade first) 
Summary0001304: Random OPL notes are muted
Description

When adding notes for any OPL instrument, sometimes, but on rare occasions, some of the notes will not play their audio, even though the channel's audio bars clearly show that they are playing audio. Moving the notes to another channel seems to temporarily resolve the issue, but when I save and close the project and later return to it, the notes are still not playing their audio.

Steps To Reproduce

It doesn't always happen, and when it does, it's random, so it is quite difficult to reproduce. Try making a lead or arp with an OPL instrument; those are the most likely to be muted.

Additional Information

Usually it happens when played alongside a different OPL instrument.

TagsNo tags attached.
Has the bug occurred in previous versions?I don't remember when I first spotted the bug, but it's been around for at least half a year.
Tested code revision (in case you know it)

Activities

Saga Musix

Saga Musix

2020-03-23 07:51

administrator   ~0004260

How many notes are playing? Remember that the OPL chip only has 18 voices, for all instruments combined.

Saga Musix

Saga Musix

2020-03-23 18:04

administrator   ~0004261

To add to the previous comment: Notes that are already playing are prioritized over new notes, i.e. when the 18-voice limit is reached, no new notes will be triggered until an already playing note is stopped. However, since the player has no insight into the OPL emulator, it will still display those notes as playing, because from the player's perspective they are still active (just like how a VSTi plugin might have its own internal voice limit, OpenMPT cannot know about this limit and cannot tell you whether the note is actually playing or not).

Especially if you are in instrument mode, pay attention to instruments with NNA set to Note Off / Fade / Continue, as such notes might jam the OPL channels for a very long time or even indefinitely.

Stardown

Stardown

2020-03-23 22:47

reporter   ~0004262

I've managed to temporarily resolve the problem by splitting one instrument, which had been used in three different ways, into three instruments. I also moved the notes that wouldn't play right into another channel, and it seems to play better now. Doing so also resolved a second instance where some notes wouldn't play.

Also, the notes were not in the first pattern, and they wouldn't play right when I chose to play that pattern. But it seemed to be fixed when I played the entire song.

All OPL notes are set to Note Cut in instrument mode.

It was the lead instrument that doesn't play some of its notes. It seems to be almost every other note that is muted. Playing at the same time is a bell, an arp, and a pad that spans eight channels (four of them are fine-pitched to enhance the other four), all of which are OPL. In another case, mentioned at the end of the first paragraph, the bell did not play some of its notes, so I moved them into another channel.

So this issue can be resolved manually; it just gets annoying sometimes. Is it possible that it's not really a bug?

Saga Musix

Saga Musix

2020-03-24 20:33

administrator   ~0004263

Well, it's always possible that there is a bug but without simple-to-reproduce steps (preferably with a module that just has to be played back), it's hard to tell.

Saga Musix

Saga Musix

2020-05-15 20:38

administrator   ~0004328

Some improvements have been made to OPL channel allocations, maybe r12840 will work better for you. It will be available for testing soon on https://builds.openmpt.org/builds/auto/openmpt/bin.win64/1.29/

Issue History

Date Modified Username Field Change
2020-03-23 01:35 Stardown New Issue
2020-03-23 03:12 Stardown Additional Information Updated View Revisions
2020-03-23 07:51 Saga Musix Note Added: 0004260
2020-03-23 18:04 Saga Musix Note Added: 0004261
2020-03-23 22:47 Stardown Note Added: 0004262
2020-03-24 20:33 Saga Musix Note Added: 0004263
2020-05-15 20:38 Saga Musix Note Added: 0004328